<?php

namespace Teknisa\CADFIS\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CADFIS\Controllers\TeknisaCrud;

class Dfs53300HistoricoCronogramaDfeController extends TeknisaCrud {
    
    protected $dataSourceName = 'dethistalteradfe';

    public function find(Filter $request, Response $response) {
        $this->dataSourceName;
        
        parent::find($request, $response);
        
        $dataSets = $response->getDataSets();
        
        $rows = isset($dataSets[0])? $dataSets[0]->getRows() : $dataSets;
        $retorno = [];
        
        foreach($rows as $position => $row) {
            $descEstados = null;
            $retorno[$position] = $row;
            
            if (strpos($row['SGESTADOAPLICA'], "_AC_") !== false) $descEstados .= "Acre, ";
            if (strpos($row['SGESTADOAPLICA'], "_AL_") !== false) $descEstados .= "Alagoas, ";
            if (strpos($row['SGESTADOAPLICA'], "_AP_") !== false) $descEstados .= "Amapá, ";
            if (strpos($row['SGESTADOAPLICA'], "_AM_") !== false) $descEstados .= "Amazonas, ";
            if (strpos($row['SGESTADOAPLICA'], "_BA_") !== false) $descEstados .= "Bahia, ";
            if (strpos($row['SGESTADOAPLICA'], "_CE_") !== false) $descEstados .= "Ceará, ";
            if (strpos($row['SGESTADOAPLICA'], "_DF_") !== false) $descEstados .= "Distrito Federal, ";
            if (strpos($row['SGESTADOAPLICA'], "_ES_") !== false) $descEstados .= "Espírito Santo, ";
            if (strpos($row['SGESTADOAPLICA'], "_GO_") !== false) $descEstados .= "Goiás, ";
            if (strpos($row['SGESTADOAPLICA'], "_MA_") !== false) $descEstados .= "Maranhão, ";
            if (strpos($row['SGESTADOAPLICA'], "_MT_") !== false) $descEstados .= "Mato Grosso, ";
            if (strpos($row['SGESTADOAPLICA'], "_MS_") !== false) $descEstados .= "Mato Grosso do Sul, ";
            if (strpos($row['SGESTADOAPLICA'], "_MG_") !== false) $descEstados .= "Minas Gerais, ";
            if (strpos($row['SGESTADOAPLICA'], "_PA_") !== false) $descEstados .= "Pará, ";
            if (strpos($row['SGESTADOAPLICA'], "_PB_") !== false) $descEstados .= "Paraíba, ";
            if (strpos($row['SGESTADOAPLICA'], "_PR_") !== false) $descEstados .= "Paraná, ";
            if (strpos($row['SGESTADOAPLICA'], "_PE_") !== false) $descEstados .= "Pernambuco, ";
            if (strpos($row['SGESTADOAPLICA'], "_PI_") !== false) $descEstados .= "Piauí, ";
            if (strpos($row['SGESTADOAPLICA'], "_RJ_") !== false) $descEstados .= "Rio de Janeiro, ";
            if (strpos($row['SGESTADOAPLICA'], "_RN_") !== false) $descEstados .= "Rio Grande do Norte, ";
            if (strpos($row['SGESTADOAPLICA'], "_RS_") !== false) $descEstados .= "Rio Grande do Sul, ";
            if (strpos($row['SGESTADOAPLICA'], "_RO_") !== false) $descEstados .= "Rondônia, ";
            if (strpos($row['SGESTADOAPLICA'], "_RR_") !== false) $descEstados .= "Roraima, ";
            if (strpos($row['SGESTADOAPLICA'], "_SC_") !== false) $descEstados .= "Santa Catarina, ";
            if (strpos($row['SGESTADOAPLICA'], "_SP_") !== false) $descEstados .= "São Paulo, ";
            if (strpos($row['SGESTADOAPLICA'], "_SE_") !== false) $descEstados .= "Sergipe, ";
            if (strpos($row['SGESTADOAPLICA'], "_TO_") !== false) $descEstados .= "Tocantins, ";
            
            $descEstados = substr_replace($descEstados, '', -2);
            $retorno[$position]['SGESTADOAPLICAEDIT'] = $descEstados;
        }
        $dataSet = new DataSet('dethistalteradfe', $retorno);
        $response->setDataSets(array($dataSet));
    }
    
    public function save(Request $request, Response $response) {
        
        parent::save($request, $response);
    }
}