<?php
namespace Teknisa\CADFIS\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;

class EndeFornService
{
    protected $dataSourceName = "import_endeforn";
    protected $entityManager;
    protected $crudService;
    
    public function __construct($entityManager, $crudService, Connection $connection, Environment $environment)
    {
        $this->entityManager = $entityManager;
        $this->crudService = $crudService;
        $this->connection = $connection;
        $this->environment = $environment;
    }
    
    public function saveImport($rows)
    {
        $dataSet = array();
        
        foreach($rows as $row){
            //Principal
            array_push($dataSet, array(
                'CDFORNECED'        => $row['CDFORNECED'],
                
                'IDTPENDEFORN'      => $row['IDTPENDEFORN'],
                'CDPAIS'            => $row['CDPAIS'],
                'SGESTADO'          => $row['SGESTADO'],
                'CDMUNICIPIO'       => $row['CDMUNICIPIO'],
                'DSENDEFORN'        => $row['DSENDEFORN'],
                'DSCOMPENDFOR'      => $row['DSCOMPENDFOR'],
                'NMBAIRFORN'        => $row['NMBAIRFORN'],
                'NRCEPFORN'         => $row['NRCEPFORN'],
                'DSEMAILFORN'       => $row['DSEMAILFORN'],
                'DSEMAILFORNNFE'    => $row['DSEMAILFORNNFE'],
                'NRCELULARFOR'      => $row['NRCELULARFOR'],
                'NRTELRESIFOR'      => $row['NRTELRESIFOR'],

                'NRORG'             => $this->environment->getNrorg(),
                'DTINCLUSAO'        => null,
                'DTULTATU'          => null,
                'NRORGINCLUSAO'     => $this->environment->getNrorg(),
                'CDOPERINCLUSAO'    => $this->environment->getCdOperador(),
                'NRORGULTATU'       => $this->environment->getNrorg(),
                'CDOPERULTATU'      => $this->environment->getCdOperador(),
                'IDATIVO'           => 'S',
                '__is_new'          => true));
            
            //Entrega
            array_push($dataSet, array(
                'CDFORNECED'        => $row['CDFORNECED'],
                
                'IDTPENDEFORN'      => $row['IDTPENDEFORNENTR'],
                'CDPAIS'            => $row['CDPAISENTR'],
                'SGESTADO'          => $row['SGESTADOENTR'],
                'CDMUNICIPIO'       => $row['CDMUNICIPIOENTR'],
                'DSENDEFORN'        => $row['DSENDEFORNENTR'],
                'DSCOMPENDFOR'      => $row['DSCOMPENDFORENTR'],
                'NMBAIRFORN'        => $row['NMBAIRFORNENTR'],
                'NRCEPFORN'         => $row['NRCEPFORNENTR'],
                'DSEMAILFORN'       => $row['DSEMAILFORNENTR'],
                'DSEMAILFORNNFE'    => $row['DSEMAILFORNNFEENTR'],
                'NRCELULARFOR'      => $row['NRCELULARFORENTR'],
                'NRTELRESIFOR'      => $row['NRTELRESIFORENTR'],

                'NRORG'             => $this->environment->getNrorg(),
                'DTINCLUSAO'        => null,
                'DTULTATU'          => null,
                'NRORGINCLUSAO'     => $this->environment->getNrorg(),
                'CDOPERINCLUSAO'    => $this->environment->getCdOperador(),
                'NRORGULTATU'       => $this->environment->getNrorg(),
                'CDOPERULTATU'      => $this->environment->getCdOperador(),
                'IDATIVO'           => 'S',
                '__is_new'          => true));
                
            //Cobrança
            array_push($dataSet, array(
                'CDFORNECED'        => $row['CDFORNECED'],
                
                'IDTPENDEFORN'      => $row['IDTPENDEFORNCOBR'],
                'CDPAIS'            => $row['CDPAISCOBR'],
                'SGESTADO'          => $row['SGESTADOCOBR'],
                'CDMUNICIPIO'       => $row['CDMUNICIPIOCOBR'],
                'DSENDEFORN'        => $row['DSENDEFORNCOBR'],
                'DSCOMPENDFOR'      => $row['DSCOMPENDFORCOBR'],
                'NMBAIRFORN'        => $row['NMBAIRFORNCOBR'],
                'NRCEPFORN'         => $row['NRCEPFORNCOBR'],
                'DSEMAILFORN'       => $row['DSEMAILFORNCOBR'],
                'DSEMAILFORNNFE'    => $row['DSEMAILFORNNFECOBR'],
                'NRCELULARFOR'      => $row['NRCELULARFORCOBR'],
                'NRTELRESIFOR'      => $row['NRTELRESIFORCOBR'],

                'NRORG'             => $this->environment->getNrorg(),
                'DTINCLUSAO'        => null,
                'DTULTATU'          => null,
                'NRORGINCLUSAO'     => $this->environment->getNrorg(),
                'CDOPERINCLUSAO'    => $this->environment->getCdOperador(),
                'NRORGULTATU'       => $this->environment->getNrorg(),
                'CDOPERULTATU'      => $this->environment->getCdOperador(),
                'IDATIVO'           => 'S',
                '__is_new'          => true));
        }
        $this->crudService->save($this->dataSourceName, $dataSet);
    }
}    