/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/******************************************************************************/
/* Nome: SEM_ABASTECIMENTO                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Calcula datas de abastecimento para um determinado mes baseando-se na      */
/* Periodicidade de abastecimento e nos Feriados.                             */
/*                                                                            */
/* Criao:                                                                   */
/* 03/07/2002 - Janaina Grazielly C. Hanashiro                                */
/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/* P_CDFILIAL     - Cdigo da Filial                                          */
/* P_CDCLIENTE    - Cdigo do Cliente                                         */
/* P_CDROTATRANS  - Cdigo da Rota                                            */
/* P_CDPERIENTR   - Cdigo da Periodicidade de Entrega                        */
/* P_DTINICIAL    - Data do Inicio do Mes                                     */
/* P_IDDIANUTIL   - Considera dia nao util                                    */
/******************************************************************************/
/* @C:\WIN_v2\SQL\end_conv\ORACLE\8676_VMNSTP_SEM_entrega.SQL               */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE SEM_ABAST_ENTREGA
  (P_CDFILIAL     IN VARCHAR2,
   P_CDROTATRANS  IN VARCHAR2,
   P_CDPERIENTR   IN VARCHAR2,
   P_DTINICIAL    IN DATE    ,
   P_IDDIANUTIL   IN VARCHAR2) IS
   V_CONTAUXI   NUMBER;
   V_DIENTREGA  VARCHAR2(2);
   V_DTDIAENTR  DATE;
   V_IDDIASEM   NUMBER;
   V_DTENTRAUX  DATE;
   V_PRIMVEZ    NUMBER;
   V_JAEXISTE   NUMBER;
   V_IDDIASANGRIA VARCHAR2(1);

   /*  Cursor que contem as datas de abastecimento no mes com base nos dias  */
   /*  de abastecimento semanais  */
   CURSOR C_DATAS_ENTR IS
       (SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR01 = '1'
      UNION
        SELECT NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR
          AND IDOCOR02   = '1'
          AND TO_CHAR(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')= TO_CHAR(P_DTINICIAL,'MM')
      UNION
        SELECT NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR
          AND IDOCOR03   = '1'
          AND TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)),
              TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')= TO_CHAR(P_DTINICIAL,'MM')
      UNION
        SELECT NEXT_DAY(NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR
          AND IDOCOR04   = '1'
          AND TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIENTREGA)),
              TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM') = TO_CHAR(P_DTINICIAL,'MM')
      UNION
        SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR
          AND IDOCOR05   = '1'
          AND TO_CHAR(NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIENTREGA)),'MM')
              = TO_CHAR(P_DTINICIAL,'MM')) ORDER BY 1;

    /*  Cursor que contem as datas de abastecimento do proximo mes
    com base nos dias de abastecimento semanais  */
   CURSOR C_DATAS_PROX IS
       (SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR01 = '1'
      UNION
        SELECT NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR02 = '1' AND
              TO_CHAR(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA)),
              TO_NUMBER(DIENTREGA)),'MM')= TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
      UNION
        SELECT NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR03 = '1' AND
              TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA)),
              TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')= TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
      UNION
        SELECT NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA))
          ,TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM  DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR04 = '1' AND
              TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),TO_NUMBER(DIENTREGA)),
              TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),TO_NUMBER(DIENTREGA)),'MM')
              = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
      UNION
        SELECT NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1)-7,TO_NUMBER(DIENTREGA)), IDDIASANGRIA
        FROM  DIASENTR
        WHERE CDPERIENTR = P_CDPERIENTR AND
              IDOCOR05 = '1' AND
              TO_CHAR(NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1),TO_NUMBER(DIENTREGA)),'MM')
              = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM')
        )ORDER BY 1;

BEGIN
   V_DTENTRAUX := P_DTINICIAL;
   OPEN C_DATAS_ENTR;
   LOOP
      FETCH C_DATAS_ENTR
      INTO V_DTDIAENTR,V_IDDIASANGRIA;
      EXIT WHEN C_DATAS_ENTR%NOTFOUND;
      /*  calcula uma data de abastecimento anterior a uma data nao util  */

      IF P_IDDIANUTIL = 'S' THEN
         V_CONTAUXI := 1;
         WHILE V_CONTAUXI > 0 LOOP
           SELECT COUNT(*) INTO V_CONTAUXI
           FROM FERIFILI
           WHERE CDFILIAL = P_CDFILIAL AND
                 DTFERIFILI = V_DTDIAENTR;
           IF V_CONTAUXI > 0 THEN
              V_DTDIAENTR := V_DTDIAENTR - 1;
           END IF;
         END LOOP;
      END IF;

      /*  Verifica se j existe a data de abastecimento que foi calculada por um dia no util */
      SELECT COUNT(*) INTO V_JAEXISTE
      FROM  CALENTREGA
      WHERE CDROTATRANS  = P_CDROTATRANS AND
            DTCALENTREGA = V_DTDIAENTR;

      /*  Se j existir a data pula  */
      IF V_JAEXISTE = 0 THEN
         /*  Verifica se ja existe alguma data de abastecimento calculada para  */
         /*  Incluir a data anterior ao proximo abastecimento  */
         SELECT COUNT(*) INTO V_PRIMVEZ
         FROM  CALENTREGA
         WHERE CDROTATRANS  = P_CDROTATRANS AND
               DTCALENTREGA = V_DTENTRAUX;
         /*  Inclui a data de abastecimento calculada no calendario de abastecimento  */
         INSERT INTO CALENTREGA
           (CDROTATRANS,DTCALENTREGA)
          VALUES
           (P_CDROTATRANS,V_DTDIAENTR);

         V_DTENTRAUX := V_DTDIAENTR;
      END IF;
   END LOOP;
   CLOSE C_DATAS_ENTR;

   /*  Pega a primeira data anterior ao proximo abastecimento  */
   OPEN C_DATAS_PROX;
   FETCH C_DATAS_PROX
   INTO V_DTENTRAUX,V_IDDIASANGRIA;
   CLOSE C_DATAS_PROX;

   IF P_IDDIANUTIL = 'S' THEN
      V_CONTAUXI := 1;
      WHILE V_CONTAUXI > 0 LOOP
         SELECT COUNT(*) INTO V_CONTAUXI
         FROM  FERIFILI
         WHERE CDFILIAL = P_CDFILIAL AND
               DTFERIFILI = V_DTENTRAUX;
         IF V_CONTAUXI > 0 THEN
            V_DTENTRAUX := V_DTENTRAUX - 1;
         END IF;
      END LOOP;
   END IF;

   V_DTENTRAUX := V_DTENTRAUX - 1;

   /*  Verifica se ja existe a ultima data de abastecimento que recebera  */
   /*  a data anterior ao proximo abastecimento  */
   SELECT COUNT(*)
   INTO  V_PRIMVEZ
   FROM  CALENTREGA
   WHERE CDROTATRANS  = P_CDROTATRANS AND
         DTCALENTREGA = V_DTDIAENTR;
END;
/
