/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8740_SUPTRGO.sql

Descrio:
Grava log de excluso de cotao.

Criao:
24/12/2003 Adriano de Arajo

@C:\WEB_410\Sql\End_Conv\Oracle\8740_SUPTRGO_GRAVA_LOGCOLETAPR.SQL
*/

CREATE OR REPLACE TRIGGER GRAVA_LOGCOLETAPR
BEFORE DELETE OR UPDATE
ON COLETAPR FOR EACH ROW

DECLARE

   V_DSREMOTEADDR   VARCHAR2(50);
   V_DSREMOTEHOST   VARCHAR2(50);
   V_DSSERVERRDM    VARCHAR2(50);
   V_DSMETUSULOG    VARCHAR2(50);
   V_DSSERVMETHOD   VARCHAR2(30);
   V_CDOPECOLLOG    VARCHAR2(12);
   V_IDGRAVLOGCOT   VARCHAR2(03);
BEGIN
   SELECT NVL(MAX(IDGRAVLOGCOT), 'SSS')
   INTO V_IDGRAVLOGCOT
   FROM PARASUPRI
   WHERE (CDFILIAL = :NEW.CDFILIAL);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_CDOPECOLLOG);

   IF UPDATING THEN
      IF SUBSTR(V_IDGRAVLOGCOT, 2, 1) = 'S' THEN
         INSERT INTO LOGCOLETAPR
         (CDFILIALLOG,  NRCOLEPRLOG, CDCOMPLOG,
          DTCOLEPRLOG,  NRSEMAINLOG, NRSEMAFILOG,
          DTINIVALLOG,  DTFINVALLOG, DTULTCOLLOG,
          DSRDMUSULOG,  DSENDUSULOG, DSNMUSULOG, DSMETUSULOG, CDOPECOLLOG,
          IDOPERCOTLOG, NRCOLEORILOG, DTINCLITMLOG, CDOPERINCLOG, IDDISMONTLOG)
         VALUES
          (:OLD.CDFILIAL,    :OLD.NRCOLEPRECO, :OLD.CDOPERADOR,
           :OLD.DTCOLEPREC,  :OLD.NRSEMAINIC,  :OLD.NRSEMAFINAL,
           :OLD.DTINIVALCOL, :OLD.DTFINVALCOL, SYSDATE,
           V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_CDOPECOLLOG,
           'A', :OLD.NRCOLEORIGCO, :OLD.DTINCLCOLET, :OLD.CDOPERINCL, :OLD.IDDISMONTLIS);
      END IF;
   END IF;

   IF DELETING THEN
      IF SUBSTR(V_IDGRAVLOGCOT, 3, 1) = 'S' THEN
         INSERT INTO LOGCOLETAPR
            (CDFILIALLOG,  NRCOLEPRLOG, CDCOMPLOG,
             DTCOLEPRLOG,  NRSEMAINLOG, NRSEMAFILOG,
             DTINIVALLOG,  DTFINVALLOG, DTULTCOLLOG,
             DSRDMUSULOG,  DSENDUSULOG, DSNMUSULOG, DSMETUSULOG, CDOPECOLLOG,
             IDOPERCOTLOG, NRCOLEORILOG, DTINCLITMLOG, CDOPERINCLOG, IDDISMONTLOG)
         VALUES
            (:OLD.CDFILIAL,    :OLD.NRCOLEPRECO, :OLD.CDOPERADOR,
             :OLD.DTCOLEPREC,  :OLD.NRSEMAINIC,  :OLD.NRSEMAFINAL,
             :OLD.DTINIVALCOL, :OLD.DTFINVALCOL, SYSDATE,
             V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_CDOPECOLLOG,
             'E', :OLD.NRCOLEORIGCO, :OLD.DTINCLCOLET, :OLD.CDOPERINCL, :OLD.IDDISMONTLIS);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_LOGCOLETAPR','4.11.076'); END;
/

